{-
   API League

   API League is a Hub for World Class APIs.

   OpenAPI Version: 3.0.0
   API League API version: 1.6.4
   Contact: mail@apileague.com
   Generated by OpenAPI Generator (https://openapi-generator.tech)
-}

{-|
Module : APILeague.API.Storage
-}

{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE MonoLocalBinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE OverloadedStrings #-}
{-# OPTIONS_GHC -fno-warn-name-shadowing -fno-warn-unused-binds -fno-warn-unused-imports #-}

module APILeague.API.Storage where

import APILeague.Core
import APILeague.MimeTypes
import APILeague.Model as M

import qualified Data.Aeson as A
import qualified Data.ByteString as B
import qualified Data.ByteString.Lazy as BL
import qualified Data.Data as P (Typeable, TypeRep, typeOf, typeRep)
import qualified Data.Foldable as P
import qualified Data.Map as Map
import qualified Data.Maybe as P
import qualified Data.Proxy as P (Proxy(..))
import qualified Data.Set as Set
import qualified Data.String as P
import qualified Data.Text as T
import qualified Data.Text.Encoding as T
import qualified Data.Text.Lazy as TL
import qualified Data.Text.Lazy.Encoding as TL
import qualified Data.Time as TI
import qualified Network.HTTP.Client.MultipartFormData as NH
import qualified Network.HTTP.Media as ME
import qualified Network.HTTP.Types as NH
import qualified Web.FormUrlEncoded as WH
import qualified Web.HttpApiData as WH

import Data.Text (Text)
import GHC.Base ((<|>))

import Prelude ((==),(/=),($), (.),(<$>),(<*>),(>>=),Maybe(..),Bool(..),Char,Double,FilePath,Float,Int,Integer,String,fmap,undefined,mempty,maybe,pure,Monad,Applicative,Functor)
import qualified Prelude as P

-- * Operations


-- ** Storage

-- *** readKeyValueFromStoreAPI

-- | @GET \/read-key-value@
-- 
-- Read Key Value from Store API
-- 
-- Read a value from the key-value store. The key-value store is a simple storage system that allows you to store and retrieve data using a key. The data is stored in the cloud and can be accessed from anywhere. You can use the key-value store to store any type of data, such as text or numbers. The key-value store is a great way to store data that you want to access from multiple devices or locations.
-- 
-- AuthMethod: 'AuthApiKeyApiKey', 'AuthApiKeyHeaderApiKey'
-- 
readKeyValueFromStoreAPI
  :: Key -- ^ "key" -  The key for which the value is stored (max length 255 characters).
  -> APILeagueRequest ReadKeyValueFromStoreAPI MimeNoContent ReadKeyValueFromStoreAPI200Response MimeJSON
readKeyValueFromStoreAPI (Key key) =
  _mkRequest "GET" ["/read-key-value"]
    `_hasAuthType` (P.Proxy :: P.Proxy AuthApiKeyApiKey)
    `_hasAuthType` (P.Proxy :: P.Proxy AuthApiKeyHeaderApiKey)
    `addQuery` toQuery ("key", Just key)

data ReadKeyValueFromStoreAPI  
-- | @application/json@
instance Produces ReadKeyValueFromStoreAPI MimeJSON


-- *** storeKeyValueGETAPI

-- | @GET \/store-key-value@
-- 
-- Store Key Value (GET) API
-- 
-- Store a value in the key-value store. The key-value store is a simple storage system that allows you to store and retrieve data using a key. The data is stored in the cloud and can be accessed from anywhere. You can use the key-value store to store any type of data, such as text or numbers. The key-value store is a great way to store data that you want to access from multiple devices or locations.
-- 
-- AuthMethod: 'AuthApiKeyApiKey', 'AuthApiKeyHeaderApiKey'
-- 
storeKeyValueGETAPI
  :: Key -- ^ "key" -  The key for which the value is stored (max length 255 characters).
  -> Value -- ^ "value" -  The value that is supposed to be stored (max length 10,000 characters).
  -> APILeagueRequest StoreKeyValueGETAPI MimeNoContent StoreKeyValueGETAPI200Response MimeJSON
storeKeyValueGETAPI (Key key) (Value value) =
  _mkRequest "GET" ["/store-key-value"]
    `_hasAuthType` (P.Proxy :: P.Proxy AuthApiKeyApiKey)
    `_hasAuthType` (P.Proxy :: P.Proxy AuthApiKeyHeaderApiKey)
    `addQuery` toQuery ("key", Just key)
    `addQuery` toQuery ("value", Just value)

data StoreKeyValueGETAPI  
-- | @application/json@
instance Produces StoreKeyValueGETAPI MimeJSON

