{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE PartialTypeSignatures #-}

module Main where

import Data.Typeable (Proxy(..))
import Test.Hspec
import Test.Hspec.QuickCheck

import PropMime
import Instances ()

import APILeague.Model
import APILeague.MimeTypes

main :: IO ()
main =
  hspec $ modifyMaxSize (const 10) $ do
    describe "JSON instances" $ do
      pure ()
      propMimeEq MimeJSON (Proxy :: Proxy ComputeNutritionAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ComputeNutritionAPI200ResponseIngredientBreakdownInner)
      propMimeEq MimeJSON (Proxy :: Proxy ComputeNutritionAPI200ResponseIngredientBreakdownInnerNutrientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy ConvertUnitsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy CorrectSpellingAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy DetectGenderByNameAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy DetectLanguageAPI200ResponseInner)
      propMimeEq MimeJSON (Proxy :: Proxy DetectMainImageColorAPI200ResponseInner)
      propMimeEq MimeJSON (Proxy :: Proxy DetectSentimentAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy DetectSentimentAPI200ResponseDocument)
      propMimeEq MimeJSON (Proxy :: Proxy DetectSentimentAPI200ResponseSentencesInner)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractAuthorsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractAuthorsAPI200ResponseAuthorsInner)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractContentFromAWebPageAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractDatesAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractDatesAPI200ResponseDatesInner)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractEntitiesAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractEntitiesAPI200ResponseEntitiesInner)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractNewsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractNewsAPI200ResponseImagesInner)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractNewsAPI200ResponseVideosInner)
      propMimeEq MimeJSON (Proxy :: Proxy ExtractPublishDateAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy FindSimilarBooksAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy GenerateNonsenseWordAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ListWordSynonymsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy PluralizeWordAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RandomMemeAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RandomPoemAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RandomQuoteAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RandomRiddleAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RandomTriviaAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ReadKeyValueFromStoreAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RetrievePageRankAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseCredits)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseDietaryProperties)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseIngredientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseIngredientsInnerMeasures)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseInstructionsInner)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseInstructionsInnerStepsInner)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseNutrition)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseNutritionIngredientBreakdownInner)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseScores)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseTaste)
      propMimeEq MimeJSON (Proxy :: Proxy RetrieveRecipeInformationAPI200ResponseTimes)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreReadabilityAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseInterestingness)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseInterestingnessSubscores)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseReadability)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseReadabilityMainscores)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseReadabilitySubscores)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseSkimmability)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseSkimmabilityMainscores)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseSkimmabilitySubscores)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseStyle)
      propMimeEq MimeJSON (Proxy :: Proxy ScoreTextAPI200ResponseStyleSubscores)
      propMimeEq MimeJSON (Proxy :: Proxy SearchBooksAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchBooksAPI200ResponseBooksInnerInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerCredits)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerIngredientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerIngredientsInnerMeasures)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerIngredientsInnerMeasuresMetric)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerIngredientsInnerMeasuresUs)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerInstructionsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerInstructionsInnerStepsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerInstructionsInnerStepsInnerIngredientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutrition)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutritionCaloricBreakdown)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutritionFlavonoidsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutritionIngredientBreakdownInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutritionIngredientBreakdownInnerNutrientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutritionNutrientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchDrinksAPI200ResponseDrinksInnerNutritionWeightPerServing)
      propMimeEq MimeJSON (Proxy :: Proxy SearchGifsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchGifsAPI200ResponseImagesInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchIconsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchJokesAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchJokesAPI200ResponseJokesInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchMemesAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchMemesAPI200ResponseMemesInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchNewsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchNewsAPI200ResponseNewsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRecipesAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRecipesAPI200ResponseRecipesInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRecipesAPI200ResponseRecipesInnerNutrition)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRecipesAPI200ResponseRecipesInnerNutritionNutrientsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRestaurantsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRestaurantsAPI200ResponseRestaurantsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRestaurantsAPI200ResponseRestaurantsInnerAddress)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRestaurantsAPI200ResponseRestaurantsInnerLocalHours)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRestaurantsAPI200ResponseRestaurantsInnerLocalHoursOperational)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRoyaltyFreeImagesAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRoyaltyFreeImagesAPI200ResponseImagesInner)
      propMimeEq MimeJSON (Proxy :: Proxy SearchRoyaltyFreeImagesAPI200ResponseImagesInnerLicense)
      propMimeEq MimeJSON (Proxy :: Proxy SearchWebAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy SearchWebAPI200ResponseResultsInner)
      propMimeEq MimeJSON (Proxy :: Proxy SingularizeWordAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy StemTextAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy StoreKeyValueGETAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy TagPartOfSpeechAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy TopNewsAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy TopNewsAPI200ResponseTopNewsInner)
      propMimeEq MimeJSON (Proxy :: Proxy TopNewsAPI200ResponseTopNewsInnerNewsInner)
      propMimeEq MimeJSON (Proxy :: Proxy VectorSearchAPI200Response)
      propMimeEq MimeJSON (Proxy :: Proxy VectorSearchAPI200ResponseVectorsInner)
      propMimeEq MimeJSON (Proxy :: Proxy VerifyEmailAddressAPI200Response)
      
